#ifndef ODBCSERVER_H
#define ODBCSERVER_H

#include <kmysql/isqlserver.h>
#include <qstring.h>
#include <sql.h>

class OdbcServer : public ISqlServer
  {
  public:
  	OdbcServer(void);
    virtual ~OdbcServer(void);
    QueryResult connect(QString, QString, QString, int);
    void close(void);
    QueryResult selectBase(QString);
    QueryResult getBases(void);
    QueryResult getTables(QString, QString = 0);
    QueryResult getColumns(QString, QString);
    QueryResult query(QString);
    QueryResult createBase(QString);
    QueryResult dropBase(QString);
    QueryResult reload(void);
    QueryResult shutdown(void);
    QString serverInfo(void);
    bool isConnected(void) { return connected; }
    IObject *queryInterface(UIID);
  private:
  	bool putTuples(QueryResult &, SQLHANDLE);
    QString sql_error( SQLHANDLE henv, SQLHANDLE hdbc, SQLHANDLE hstmt ); 
    void split_name( const char * source, SQLCHAR *catalog, 
        SQLCHAR *schema, SQLCHAR *table );
  private: 
    bool connected; 
    QString odbc_dsn; 
    QString odbc_user; 
    QString odbc_passwd;
    SQLHANDLE henv; 
    SQLHANDLE hdbc; 
  };


#endif
